> module Rohrmeier where
> import GrammarMonad hiding (Rule, S)
> import System.Random
> import Data.List

Donya Quick
Last modified: 22-Mar-2014

Type definitions to support Rohrmeier's grammar

P = {piece, P} 
R = {TR, SR, DR} functional region symbols
K = {Cmaj, Cmin, ...} key symbols
F = {t, s, d, tp, sp, dp, tcp} functional term symbols
S = {I, II, ...} scale degree chord representations
O = {Cmaj, ...} surface chord symbols (e.g. I in K=Cmaj)

> data RTerm = Piece | P |
>              TR | DR | SR | 
>              T | D | S | TP | TCP | SP | DP | 
>              C CType
>     deriving (Eq, Read)

> allRTerms = [Piece, P, TR, DR, SR, T, D, S, TP, TCP, SP, DP, 
>              C I, C II, C III, C IV, C V, C VI, C VII]

> instance Show RTerm where
>     show Piece = "Piece"
>     show P = "P"
>     show TR = "TR"
>     show DR = "DR"
>     show SR = "SR"
>     show T = "T"
>     show D = "D"
>     show S = "S"
>     show TP = "TP"
>     show TCP = "TCP"
>     show SP = "SP"
>     show DP = "DP"
>     show (C x) = show x


> showRTerms :: [RTerm] -> String
> showRTerms [] = ""
> showRTerms [t] = show t
> showRTerms (t1:ts) = show t1 ++ " " ++ showRTerms (ts)

